/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


#ifndef asltype_HXX
#define asltype_HXX

#include "sockrpc.hxx"

#define Table ListVal
#define IterTable IterListVal
#define Flot ListVal
#define Flow ListVal
#define IterFlot IterListVal

#define TypeEntier int
#define TypeReel double
#define TypeCaractere char

struct TypePoint {
  double x,y,z;

  inline friend SvcSocket& operator<<(SvcSocket& s, TypePoint& pt) {
    s << pt.x << pt.y << pt.z ; return s ;
  }
  inline friend SvcSocket& operator>>(SvcSocket& s, TypePoint& pt) {
    s >> pt.x >> pt.y >> pt.z ; return s ;
  }
} ;

struct TypeCadre {
  TypePoint pt1, pt2;

  inline friend SvcSocket& operator<<(SvcSocket& s, TypeCadre& cadre) {
    s << cadre.pt1 << cadre.pt2 ; return s ;
  }
  inline friend SvcSocket& operator>>(SvcSocket& s, TypeCadre& cadre) {
    s >> cadre.pt1 >> cadre.pt2 ; return s ;
  }
} ;

#endif
